/*
	$Id: FirstCharFinder.java 305 2007-03-16 18:35:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

/**
   ǽ˽иʸ򸡺ѡ
*/
public class FirstCharFinder implements CommentedString.ParsedListener {
    /** ʸ */
    private char c;

    /** ִ */
    private int index;

    /** ˥ѡʸ */
    private int total;

    /**
       ǽ˽иʸ򸡺ѡΥ󥹥󥹤ޤ

       @param c ʸ
    */
    public FirstCharFinder(final char c) {
	this.c = c;
	index = -1;
	total = 0;
    }

    /**
       ִ̤ޤ

       @return ʸȯ֡ޤ-1
    */
    public int getResult() {
	return index;
    }

    public boolean textNotify(final String sub) {
	int k = sub.indexOf(c);
	if (k == -1) {
	    total += sub.length();
	    return false;
	} else {
	    index = total + k;
	    return true;
	}
    }

    public boolean commentNotify(final String sub) {
	total += sub.length();
	return false;
    }
}
